<?php
class WoocommerceIR_Gateways_SMS {
    
	private static $_instance;
	private $wsdl_link = "http://ip.sms.ir/ws/SendReceive.asmx?wsdl";
	private $wsdl_link_users = "http://ip.sms.ir/ws/Users.asmx?wsdl";
	
	public static function init() {
        if ( !self::$_instance )
            self::$_instance = new WoocommerceIR_Gateways_SMS();
        return self::$_instance;
    }
	
    public function SendSMSir( $sms_data ) {
		$response = false;
        $username = ps_sms_options( 'persian_woo_sms_username', 'sms_main_settings' );
        $password = ps_sms_options( 'persian_woo_sms_password', 'sms_main_settings' );
        $from = ps_sms_options( 'persian_woo_sms_sender', 'sms_main_settings' );
		$clubnum_check = ps_sms_options( 'persian_woo_sms_sender_clubnum', 'sms_main_settings' );
        $message = $sms_data['sms_body'];
		$numbers1 = $sms_data['number'];
		
		if (strpos($message, '&#xfdfc;') != false) {
			$message = str_replace("&#xfdfc;","ریال",$message);
		}

		if($numbers1){
			@$numbers = array_unique($numbers1);
			@$numbersfloat = array_map('floatval',$numbers);
			
			if ( empty( $username ) || empty( $password ) ) {
				return $response;
			}

			if (extension_loaded('soap')) {

				$parameters['userName'] = $username;
				$parameters['password'] = $password;
				$parameters['mobileNos'] = $numbersfloat;
				$parameters['messages'] = $message;
				$parameters['lineNumber'] = $from; 
				$parameters['sendDateTime'] = date("Y-m-d")."T".date("H:i:s");

				date_default_timezone_set('Asia/Tehran');
				$client= new SoapClient($this->wsdl_link);
				if($clubnum_check == "on"){
					if (count($numbersfloat) == 1) {
						$num = $numbersfloat[0];

						$ccparameters['userName'] = $username;
						$ccparameters['password'] = $password;
						$ccparameters['messageBody'] = $message;
						$ccparameters['mobile'] = $num;
						$ccparameters['message'] = $message; 

						$check_if_in_cc = $this->inserttosmscustomerclub("",$num);
						$SendMessageToOneCustomerClub = $client->SendMessageToOneCustomerClub($ccparameters);
						$SendToOneCustomerClub = get_object_vars($SendMessageToOneCustomerClub);
						$SendToOneCustomerClubresult = $SendToOneCustomerClub['SendMessageToOneCustomerClubResult'];
						if($SendToOneCustomerClubresult == 1){
							$response = true;
						} else {
							$response = false;
						}
					} else {
						$SendMessage = $client->SendBulkMessageWithLineNumber($parameters);
						if($SendMessage != null){
							$SendMessageWithLine = get_object_vars($SendMessage);
						}
						$sendresult = $SendMessageWithLine['SendBulkMessageWithLineNumberResult'];
						if($sendresult != null){
							$transid = get_object_vars($sendresult);
						}
						$transidvalue = $transid['long'];
						if($transidvalue){
							$response = true;
						} else {
							$response = false;
						}
					}
				} else {
					$SendMessage = $client->SendBulkMessageWithLineNumber($parameters);
					if($SendMessage != null){
						$SendMessageWithLine = get_object_vars($SendMessage);
					}
					$sendresult = $SendMessageWithLine['SendBulkMessageWithLineNumberResult'];
					if($sendresult != null){
						$transid = get_object_vars($sendresult);
					}
					$transidvalue = $transid['long'];
					if($transidvalue){
						$response = true;
					} else {
						$response = false;
					}
				}
			} else {
				$response = false;
			}
		} else {
			$response = false;
		}
        return $response;
	}
	
	public function GetCredit() {
		
		$parameters['userName'] = ps_sms_options( 'persian_woo_sms_username', 'sms_main_settings' );
		$parameters['password'] = ps_sms_options( 'persian_woo_sms_password', 'sms_main_settings' );

		date_default_timezone_set('Asia/Tehran');
		$client= new SoapClient($this->wsdl_link);
		$UserCredit = $client->GetUserCredit($parameters);
		$UserCreditget = get_object_vars($UserCredit);
		$UserCreditresult = $UserCreditget['GetUserCreditResult'];
		$UserCreditres = doubleval($UserCreditresult);
		return $UserCreditres;
	}
	
	public function SendSMStoCustomerclubContacts($message) {
	
		date_default_timezone_set('Asia/Tehran');
		$client= new SoapClient($this->wsdl_link);
		
		$parameters['userName'] = ps_sms_options( 'persian_woo_sms_username', 'sms_main_settings' );
		$parameters['password'] = ps_sms_options( 'persian_woo_sms_password', 'sms_main_settings' );
		$parameters['messageBody'] = $message['sms_body'];
		$parameters['message'] = $message['sms_body']; 

		$SendMessage = $client->SendMessageCustomerClub($parameters);
		
		$SendMessageWithLine = get_object_vars($SendMessage);
		$sendresult = $SendMessageWithLine['SendMessageCustomerClubResult'];

		if($sendresult == 1){
			return true;
		} else {
			return false;
		}
	}
	public function inserttosmscustomerclub($user_name,$mobile){
		if($mobile){
			$parameters['userName'] = ps_sms_options( 'persian_woo_sms_username', 'sms_main_settings' );
			$parameters['password'] = ps_sms_options( 'persian_woo_sms_password', 'sms_main_settings' );
			$parameters['lastName'] = $user_name;
			$parameters['mobile'] = $mobile;

			date_default_timezone_set('Asia/Tehran');
			$client= new SoapClient($this->wsdl_link_users);
			$insertTocustomerclub = $client->InserNewContactCustomerClub($parameters);
			
			$customerclubget = get_object_vars($insertTocustomerclub);
			$customerclubresult = $customerclubget['InserNewContactCustomerClubResult'];
			if($customerclubresult == 1){
				return true;
			} else {
				return false;
			}
		}
	}	
}